<?php
/**
 * HOOK interface for classes which hook into tslib_content and do additional stdWrap processing
 *
 */
 
require_once ( $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate') . "plugins/function.editIcon.php" );
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('frontend').'Classes/ContentObject/ContentObjectStdWrapHookInterface.php'); // TYPO3 6.0+
class tx_phptemplate_analog_stdwrap implements \TYPO3\CMS\Frontend\ContentObject\ContentObjectStdWrapHookInterface {

	/**
	 * Hook for modifying $content before core's stdWrap does anything
	 *
	 * @param	string		input value undergoing processing in this function. Possibly substituted by other values fetched from another source.
	 * @param	array		TypoScript stdWrap properties
	 * @param	tslib_cObj	parent content object
	 * @return	string		further processed $content
	 */
	public function stdWrapPreProcess($content, array $configuration, \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer &$parentObject) {
			// При условии, что это режим редактирования
		if ($GLOBALS['BE_USER']->uc['phptemplate_mode_editing'] == 2 && $configuration['editPanel'] == 1) {
			if($configuration['editPanel.']['tableName'] == "tt_content"){
				$editIcon = phptemplate_plugin_editIcon_marker('tt_content',$parentObject->data['uid'],false,array('isEditRecord_tt_content' => 1),1);
				$moveIcon = phptemplate_plugin_editIcon_marker('tt_content',$parentObject->data['uid'],$GLOBALS['LANG']->sL('LLL:EXT:phptemplate/locallang.xml:hooks.addAfter'),array('isMoveRecord_tt_content' => 1),0);
				if ($parentObject->data['CType'] == "shortcut" || $parentObject->data['CType'] == "list" || $parentObject->data['CType'] == "box" || $parentObject->data['CType'] == "box_int") {
						// Здесь делаем так, что бы небыло наложений кнопок
					return "<tagWrapTtContentElement class='tagWrapTtContentElement' style='padding-bottom: 12px;'>
								<tagWrapTtContentElement_dashed_Left	class='tagWrapTtContentElement_dashed_Left'></tagWrapTtContentElement_dashed_Left>
								" . $editIcon . $content . $moveIcon . "
							</tagWrapTtContentElement>";
				} else {
					return "<tagWrapTtContentElement class='tagWrapTtContentElement'>
								<tagWrapTtContentElement_dashed_Top		class='tagWrapTtContentElement_dashed_Top'></tagWrapTtContentElement_dashed_Top>
								<tagWrapTtContentElement_dashed_Right	class='tagWrapTtContentElement_dashed_Right'></tagWrapTtContentElement_dashed_Right>
								<tagWrapTtContentElement_dashed_Bottom	class='tagWrapTtContentElement_dashed_Bottom'></tagWrapTtContentElement_dashed_Bottom>
								<tagWrapTtContentElement_dashed_Left	class='tagWrapTtContentElement_dashed_Left'></tagWrapTtContentElement_dashed_Left>
								" . $editIcon . $content . $moveIcon . "
							</tagWrapTtContentElement>";
				}
			} else {
				$tableName = $configuration['editPanel.']['tableName'];
				$title = $configuration['editPanel.']['title'];
				$otherArg = $configuration['editPanel.']['otherArg.'];
				$editIcon = phptemplate_plugin_editIcon_marker($tableName,$parentObject->data['uid'],$title,$otherArg,1);
					return "<tagWrapTtContentElement class='tagWrapTtContentElement'>
								<tagWrapTtContentElement_dashed_Top		class='tagWrapTtContentElement_dashed_Top'></tagWrapTtContentElement_dashed_Top>
								<tagWrapTtContentElement_dashed_Right	class='tagWrapTtContentElement_dashed_Right'></tagWrapTtContentElement_dashed_Right>
								<tagWrapTtContentElement_dashed_Bottom	class='tagWrapTtContentElement_dashed_Bottom'></tagWrapTtContentElement_dashed_Bottom>
								<tagWrapTtContentElement_dashed_Left	class='tagWrapTtContentElement_dashed_Left'></tagWrapTtContentElement_dashed_Left>
								" . $editIcon . $content . "
							</tagWrapTtContentElement>";
			}
		} else {
			return $content;
		}
	}

	/**
	 * Hook for modifying $content after core's stdWrap has processed setContentToCurrent, setCurrent, lang, data, field, current, cObject, numRows, filelist and/or preUserFunc
	 *
	 * @param	string		input value undergoing processing in this function. Possibly substituted by other values fetched from another source.
	 * @param	array		TypoScript stdWrap properties
	 * @param	tslib_cObj	parent content object
	 * @return	string		further processed $content
	 */
	public function stdWrapOverride($content, array $configuration, \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer &$parentObject) {
		return $content;
	}

	/**
	 * Hook for modifying $content after core's stdWrap has processed override, preIfEmptyListNum, ifEmpty, ifBlank, listNum, trim and/or more (nested) stdWraps
	 *
	 * @param	string		input value undergoing processing in this function. Possibly substituted by other values fetched from another source.
	 * @param	array		TypoScript "stdWrap properties".
	 * @param	tslib_cObj	parent content object
	 * @return	string		further processed $content
	 */
	public function stdWrapProcess($content, array $configuration, \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer &$parentObject) {
		return $content;
	}

	/**
	 * Hook for modifying $content after core's stdWrap has processed anything but debug
	 *
	 * @param	string		input value undergoing processing in this function. Possibly substituted by other values fetched from another source.
	 * @param	array		TypoScript stdWrap properties
	 * @param	tslib_cObj	parent content object
	 * @return	string		further processed $content
	 */
	public function stdWrapPostProcess($content, array $configuration, \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer &$parentObject) {
		return $content;
	}

}
?>