<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Rupert Germann <rg@rgdata.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * Extend the internal exception handler
 *
 */

# require_once (PATH_t3lib.'interfaces/interface.t3lib_singleton.php');
# require_once (PATH_t3lib.'error/interface.t3lib_error_exceptionhandlerinterface.php');
# require_once (PATH_t3lib.'error/class.t3lib_error_abstractexceptionhandler.php');
# require_once (PATH_t3lib.'error/class.t3lib_error_debugexceptionhandler.php');

class tx_phptemplate_error_postExceptionsOnTwitterWithClearBufer extends t3lib_error_DebugExceptionHandler {

	public function echoExceptionWeb(Exception $exception) {
		//-- Call Hook (очень понадобилось для расширения tx_spiderindexing на исключение страницы из индекса) -- //
		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['GLOBAL']['tx_phptemplate_pageErrorHandlerAndExceptionWebHook'])) {
			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['GLOBAL']['tx_phptemplate_pageErrorHandlerAndExceptionWebHook'] as $_funcRef) {
				$GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::callUserFunction($_funcRef, $params, $pObj);
			}
		}
		//-- Clear bufer -- //
		while (ob_get_level()>0) {
			@ob_end_clean();
		}
		# $this->postExceptionsOnTwitter($exception);
		parent::echoExceptionWeb($exception);

	}
		// clear <div> and other tags
	protected function getCodeSnippet($filePathAndName, $lineNumber) {
		$codeSnippet = '<br />';
		if (@file_exists($filePathAndName)) {
			$phpFile = @file($filePathAndName);
			if (is_array($phpFile)) {
				$startLine = ($lineNumber > 2) ? ($lineNumber - 2) : 1;
				$endLine = ($lineNumber < (count($phpFile) - 2)) ? ($lineNumber + 3) : count($phpFile) + 1;
				if ($endLine > $startLine) {
					$codeSnippet = '<br /><span style="font-size:10px;">' . $filePathAndName . ':</span><br /><pre>';
					for ($line = $startLine; $line < $endLine; $line++) {
						$codeLine = str_replace(TAB, ' ', $phpFile[$line - 1]);

						if ($line === $lineNumber) {
							$codeSnippet .= '</pre><pre style="background-color: #F1F1F1; color: black;">';
						}
						$codeSnippet .= sprintf('%05d', $line) . ': ' . htmlspecialchars($codeLine); // ! ADD htmlspecialchars
						if ($line === $lineNumber) {
							$codeSnippet .= '</pre><pre>';
						}
					}
					$codeSnippet .= '</pre>';
				}
			}
		}
		return $codeSnippet;
	}
	# function postExceptionsOnTwitter($exception) {
	# 	echo '<div style="padding:20px;"><strong>@TODO withClearBuber: write the code to post this exception to twitter ;-)</strong></div>';
	# }
}

?>