<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014  <Ivan Litovchenko>
 *  All rights reserved
 ***************************************************************/

# error_reporting(E_ALL);
# ini_set("display_errors", 1);

require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('frontend').'Classes/ContentObject/ContentObjectGetSingleHookInterface.php'); // TYPO3 6.0+
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'pi1/class.tx_phptemplate_controller.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.adminPanel.php');
require_once($GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_extMgm']::extPath('phptemplate').'plugins/function.editIcon.php');

class tx_phptemplate implements \TYPO3\CMS\Frontend\ContentObject\ContentObjectGetSingleHookInterface { 
        
	public $prefixId      = 'tx_phptemplate'; // Same as class name
	public $scriptRelPath = 'pi1/class.tx_phptemplate.php'; // Path to this script relative to the extension dir.
	public $extKey        = 'phptemplate'; // The extension key.
	public $conf		  = array();
	public $userClassName;
	
	public function getSingleContentObject($contentObjectName, array $configuration, $TypoScriptKey, \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer &$parentObject) {
		$this->cObj = &$parentObject; 
		$this->conf = $configuration;

		switch($contentObjectName) { 
			
				// Панель администрирования
			case 'T3_ADMIN_PANEL': 
				return phptemplate_plugin_adminPanel(false);
			break; 
			case 'T3_ADMIN_PANEL_FOOTER': 
				return phptemplate_plugin_adminPanel(false, 1); // footer
			break; 
			
				// Иконки редактирования и Wrap-ы
			# case 'T3_EDIT_ICON': 
			# 	return ""; // footer
			# break; 
			
				// Панель с заметками
			# case 'T3_ADMIN_PANEL_NOTEPAD': 
			# 	return "";
			# break; 
			
				// Объекты для использования в Typoscript
			case 'PHPTEMPLATE': 
				$this->cObj->typeObject = "NOT_INT"; // помечаем для таких функций как changePageTitle()
				return $this->PHPTEMPLATE($configuration);
			break; 
			case 'PHPTEMPLATE_INT':
				$this->cObj->typeObject = "INT"; // помечаем для таких функций как changePageTitle()
				return $this->PHPTEMPLATE_INT($configuration);
			break;
			
		} 
	}
	
	/**
     * Rendering the cObject, PHPTEMPLATE
     *
     * @param    array        Array of TypoScript properties
     * @return    string        Output
     */
    function PHPTEMPLATE($conf) {
		# $conf['includeLibs'] = "EXT:phptemplate/pi1/class.tx_phptemplate_controller.php";
		# $conf['userFunc'] = "tx_phptemplate_controller->main";

		$conf = $this->ifIssetUserClass($conf);
		$content = $this->cObj->callUserFunction($conf['userFunc'], $conf, '');
		return $this->classControllerIfNotExists($content);
    }
	
	/**
     * Rendering the cObject, PHPTEMPLATE_INT
     *
     * @param    array        Array of TypoScript properties
     * @return    string        Output
     */
	function PHPTEMPLATE_INT($conf) {
		$substKey = 'INT_SCRIPT.' . $GLOBALS['TSFE']->uniqueHash();
		$content = '<!--' . $substKey . '-->';
		
		# $conf['includeLibs'] = "EXT:phptemplate/pi1/class.tx_phptemplate_controller.php";
		# $conf['userFunc'] = "tx_phptemplate_controller->main";
		
		$conf = $this->ifIssetUserClass($conf);
		$GLOBALS['TSFE']->config['INTincScript'][$substKey] = array (
				'file' => $conf['includeLibs'],
				'conf' => $conf,
				'cObj' => serialize($this->cObj),
				'type' => 'FUNC'
		);
		$content = '<!--' . $substKey . '-->';
		return $this->classControllerIfNotExists($content);
	}
	
		// Проверка сущестования пользовательского класса-контроллера, переданного в параметрах "controller_file"
	function ifIssetUserClass($conf) {
		if (isset($conf['controller_file'])) {
			$filename = explode("&", $conf['controller_file']);
			$filename[1] = "tx_phptemplate_controller_" . $filename[1]; // добавляем обязательный префикс
			
			$conf['includeLibs'] = $filename[0]; // PATH_site . $filename[0];
			$conf['userFunc'] = $filename[1] . "->main"; // запуск пользовательского класса-контроллера
			$this->userClassName = $filename[1];
			
			$pathFileController = $GLOBALS['TYPO3_CLASS_MIGRATION']['t3lib_div']::getFileAbsFileName($filename[0]);
			if (file_exists($pathFileController) && is_file($pathFileController)) {
				require_once ($pathFileController);			
			}
			
				// Если класс не найден, устанавливаем стандартный контроллер, там выдадим ошибку
			# if (!class_exists($filename[1])){
			#	
			#	# $conf['includeLibs'] = "EXT:phptemplate/pi1/class.tx_phptemplate_controller.php";
			#	# $conf['userFunc'] = "tx_phptemplate_controller->main";
			# }
			
		} else {
			$conf['includeLibs'] = "EXT:phptemplate/pi1/class.tx_phptemplate_controller.php";
			$conf['userFunc'] = "tx_phptemplate_controller->main";
		}
		return $conf;
	}
	
		// Выдача ошибки, если пользовательский класс-контроллер не найден или не существует
	function classControllerIfNotExists($content) {
		if (isset($this->userClassName) && !class_exists($this->userClassName)) {
			# $GLOBALS['TSFE']->pageUnavailableAndExit('Пользовательский контроллер (' . $conf['controller_file'] . ') не найден!');
			return tx_phptemplate_error_wrap('User controller (' . $this->conf['controller_file'] . ') not found!');
		} else {
			return $content;
		}
	}
	
}

?>