<?php
/*
	Небольшие вспомогательные прямые функции
*/
	
	
	// Функция возвращяет значение по умолчанию, если оно не определено
function __d__($str, $def){
	if(!empty($str)){
		return $str;
	} else {
		return $def;
	}
}

	// Функция не позволяет испортить значение атрибута тэга <img title="" alt="">
function __h__($str){
	return htmlspecialchars($str);
}

	// Функция определяет - включен ли режим редактирования
function __editMode__(){
	if ($GLOBALS['BE_USER']->uc['phptemplate_mode_editing'] == 2) {
		return TRUE;
	} else {
		return FALSE;
	}
}

		// Новое название
	function __is_editMode__(){ 
		return __editMode__(); 
	}
	
	// Функция определет работает ли режим eIdAjax
function __is_eIdAjaxMode__(){
	if (defined("TYPO3_MODE_eIdAjax")==TRUE) {
		return TRUE;
	} else {
		return FALSE;
	}
}

	// Функция возвращяет путь к текущему шаблоноу
function __tplPath__(){
	$GLOBALS['tx_phptemplate_func_tplPath'] = str_replace($GLOBALS['_SERVER']['DOCUMENT_ROOT'].'/', '', $GLOBALS['tx_phptemplate_func_tplPath']);
	$GLOBALS['tx_phptemplate_func_tplPath'] = str_replace('template.php', '', $GLOBALS['tx_phptemplate_func_tplPath']);
	return $GLOBALS['tx_phptemplate_func_tplPath'];
}

	// Функция переводов
	// @_sqlInsertExec - данные параметр, что бы не зацикливалась вставка!
function ___LLL___($idTranslateGroup, $idTranslate, $default = "", $markers_list_replace = array(), $_sqlInsertExec = TRUE){
	
		// Осуществляем поиск маркера
	// $tplPath = $GLOBALS['tx_phptemplate_func_LLL'];
	$tplPath = $idTranslateGroup;
	
	$q = DB::run()->table('tx_web_localization')->select('uid,title,sys_language_uid,key_path_template,key_marker_uid');
	$q->where("telem", 				"=", 0);
	$q->where("pelem", 				"=", $tplPath); // это дубликат "key_path_template" - пока решил оставить так!
	$q->where("key_path_template", 	"=", $tplPath);
	$q->where("key_marker_uid", 	"=", intval($idTranslate));
	$q->limit(1);
	$row = $q->exec();
	
	#print_r($row);
	#exit();
	
		// Если маркер не существует - создаем маркер-перевод и после создания отправляем на повторный перевод
	if(count($row) == 0 && $idTranslate > 0 && $_sqlInsertExec == TRUE){
		$data = array(
			"title" => $default,
			"telem" => '0',	
			"pelem" => $tplPath, // это дубликат "key_path_template" - пока решил оставить так!
			"key_path_template" => $tplPath,
			"key_marker_uid" => intval($idTranslate),
			"sys_language_uid" => 0
		);
		$insertId = DB::run()->table("tx_web_localization")->insert($data)->exec();
		if($insertId > 0){
			return ___LLL___($idTranslateGroup, $idTranslate, $default, $markers_list_replace, FALSE);
		} else {
			return $default;
		}
	}

		// Делаем update в БД - поля title
	if($row[0]['title'] != $default && $row[0]['sys_language_uid'] <= 0 && $idTranslate > 0 && count($row) == 1){
		
		$data = array();
		$data['title'] = $default;
		$q = DB::run()->table('tx_web_localization')->update($data);
		$q->where("telem", 				"=", 0);
		$q->where("pelem", 				"=", $tplPath); // это дубликат "key_path_template" - пока решил оставить так!
		$q->where("key_path_template", 	"=", $tplPath);
		$q->where("key_marker_uid", 	"=", intval($idTranslate));
		$q->where("sys_language_uid", 	"=", $row[0]['sys_language_uid']);
		$q->limit(1);
		$affectRow = $q->exec();
		
		$row[0]['title'] = $default;
	}
	
		// Заменяем маркеры в переводе (если есть))
	if(count($markers_list_replace) > 0){
		foreach ($markers_list_replace as $key => $value){

				// Если пустое значение
			if (trim($value) == null)
				$value = "-";
						
			$row[0]['title'] = str_replace(
				"[" . $key . "]", 
				$value, 
				$row[0]['title']
			);
		}
	}
	
		// Записываем глобально для adminPanelNotepad.php (пока решил отказаться от данной поддержки)
	// $GLOBALS['tx_phptemplate_func_LLL'][] = $row[0];
	
		// Если авторизированы в Backend, выводим информацию о маркере
	if(isset($GLOBALS['BE_USER']) && $GLOBALS['BE_USER']->uc['phptemplate_checkLocalization'] == 1){
		#if($row[0]['key_marker_uid'] == NULL){
		#	$row[0]['key_marker_uid'] = "?";
		#}
		return "&#10052; ".$row[0]['key_marker_uid'].". &#9658;" . $row[0]['title']."&#9668;";
	} else {
		return $row[0]['title'];
	}

}

	// Функция переводов картинок
	// @_sqlInsertExec - данные параметр, что бы не зацикливалась вставка!
function ___LLLImage___($idTranslateGroup, $imgPath, $_sqlInsertExec = TRUE){

	// Получаем расширение изображения
	// Получаем путь 
/*
	Array
	(
		[dirname] => fileadmin/dev/img
		[basename] => header4-3.jpg
		[extension] => jpg
		[filename] => header4-3
	)
*/
	$pInfo = pathinfo($imgPath);
	$dirname = $pInfo['dirname']; 
	$basename = $pInfo['basename']; 
	$extension = $pInfo['extension']; 
	$filename = $pInfo['filename']; 
	
	// Получаем код языка
	$langCode = $GLOBALS['TSFE']->config['config']['language'];
	
		// Осуществляем поиск маркера
	// $tplPath = $GLOBALS['tx_phptemplate_func_LLL'];
	$tplPath = $idTranslateGroup;
	
	$q = DB::run()->table('tx_web_localization')->select('uid,title,sys_language_uid,key_path_template,key_marker_image_path,key_marker_image_path_sys_language_uid_list');
	$q->where("telem", 				"=", 'image');
	$q->where("pelem", 				"=", $tplPath); // это дубликат "key_path_template" - пока решил оставить так!
	$q->where("key_path_template", 	"=", $tplPath);
	$q->where("key_marker_image_path", 	"=", $imgPath);
	$q->whereSysLanguageId(0);
	$q->limit(1);
	$row = $q->exec();
	
	#print_r($row);
	#exit();

		// Если маркер не существует - создаем маркер-перевод
	if(count($row) == 0 && isset($imgPath)){ // && $GLOBALS['TSFE']->sys_language_uid == 0
		$data = array(
			"title" => $imgPath,
			"telem" => 'image',	
			"pelem" => $tplPath, // это дубликат "key_path_template" - пока решил оставить так!
			"key_path_template" => $tplPath,
			"key_marker_image_path" => $imgPath,
			"sys_language_uid" => 0
		);
		$insertId = DB::run()->table("tx_web_localization")->insert($data)->exec();
		if($insertId > 0){
			return ___LLLImage___($idTranslateGroup, $imgPath, FALSE);
		} else {
			return $imgPath;
		}
	} 
	
		// Если маркер существует - делаем update
	if(isset($row) && isset($imgPath) && $GLOBALS['TSFE']->sys_language_uid > 0) {
		$data = array();
		$data['key_marker_image_path_sys_language_uid_list'] = unserialize($row[0]['key_marker_image_path_sys_language_uid_list']);
		$data['key_marker_image_path_sys_language_uid_list'][$GLOBALS['TSFE']->sys_language_uid] = $langCode;
		$data['key_marker_image_path_sys_language_uid_list'] = serialize($data['key_marker_image_path_sys_language_uid_list']);

		$q = DB::run()->table('tx_web_localization')->update($data);
		$q->where("telem", 					"=", 'image');
		$q->where("pelem", 					"=", $tplPath); // это дубликат "key_path_template" - пока решил оставить так!
		$q->where("key_path_template", 		"=", $tplPath);
		$q->where("key_marker_image_path", 	"=", $imgPath);
		$q->where("sys_language_uid", 		"=", $row[0]['sys_language_uid']);
		$q->limit(1);
		$affectRow = $q->exec();
	}
	
	# print $GLOBALS['TSFE']->sys_language_uid;
	# print_r($langCode);
	# print PATH_site . $dirname . '/' . $filename . '.'.$langCode.'.' . $extension;
	# exit();
	
		/* Если язык = 0 (по умолчанию показываем данное изображение) */
	if($GLOBALS['TSFE']->sys_language_uid == 0){
		return $imgPath;
	} elseif (isset($langCode) && file_exists(PATH_site . $dirname . '/' . $filename . '.'.strtoupper($langCode).'.' . $extension)) {
		return $dirname . '/' . $filename . '.'.strtoupper($langCode).'.' . $extension;
	} else {
		return $imgPath;
	}
}

?>